> This page is for Taurus PROTECT, version v3.44.
> For other versions, use one of these documentation indexes:
> - v3.58 (default): https://taurushq.ferndocs.com/protect-capital/v3.58/llms.txt
> - v3.56: https://taurushq.ferndocs.com/protect-capital/v3.56/llms.txt
> - v3.54: https://taurushq.ferndocs.com/protect-capital/v3.54/llms.txt
> - v3.52: https://taurushq.ferndocs.com/protect-capital/v3.52/llms.txt
> - v3.50: https://taurushq.ferndocs.com/protect-capital/v3.50/llms.txt
> - v3.48: https://taurushq.ferndocs.com/protect-capital/v3.48/llms.txt
> - v3.46: https://taurushq.ferndocs.com/protect-capital/v3.46/llms.txt
> - v3.44: https://taurushq.ferndocs.com/protect-capital/v3.44/llms.txt
> - v3.42: https://taurushq.ferndocs.com/protect-capital/v3.42/llms.txt
> - v3.40: https://taurushq.ferndocs.com/protect-capital/v3.40/llms.txt
> - v3.38: https://taurushq.ferndocs.com/protect-capital/v3.38/llms.txt

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://taurushq.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://taurushq.ferndocs.com/_mcp/server.

# List users in a restricted visibility group

GET https://your-protect-instance.example.com/api/rest/v1/visibilitygroups/{visibilityGroupID}/users

This endpoint returns a list of users in a given restricted visibility group

Reference: https://taurushq.ferndocs.com/protect-capital/reference/visibility-groups/get-users-by-id

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Path parameters

- `visibilityGroupID` (string, required)

## Response

### 200

A successful response.

- `result` (list of tgvalidatordInternalUser, optional)

## Errors

### 400 Bad Request Error

Bad Request: indicates that the server cannot or will not process the request due to something that is perceived to be a client error (for example, malformed request syntax, invalid request message framing, or deceptive request routing)

- `any`

### 401 Unauthorized Error

Unauthorized: indicates that the client request has not been completed because it lacks valid authentication credentials for the requested resource

- `any`

### 403 Forbidden Error

Forbidden: indicates that the server understands the request but refuses to authorize it

- `any`

### 404 Not Found Error

Not Found: indicates that the server cannot find the requested resource

- `any`

### 500 Internal Server Error

Internal Server Error: indicates that the server encountered an unexpected condition that prevented it from fulfilling the request

- `any`

### 503 Service Unavailable Error

Service Unavailable: indicates that the server is not ready to handle the request.

- `any`

## Types

### tgvalidatordInternalUser

- `id` (string, optional)
- `tenantId` (string, optional)
- `externalUserId` (string, optional)
- `firstName` (string, optional)
- `lastName` (string, optional)
- `status` (string, optional)
- `email` (string, optional)
- `roles` (list of string, optional)
- `passwordChanged` (boolean, optional)
- `publicKey` (string, optional)
- `groups` (list of tgvalidatordInternalUserGroup, optional)
- `enforcedInRules` (boolean, optional)
- `creationDate` (datetime, optional)
- `updateDate` (datetime, optional)
- `totpEnabled` (boolean, optional)
- `keyContainer` (InternalUserKeyContainer, optional)
- `username` (string, optional)
- `lastLogin` (datetime, optional)
- `attributes` (list of InternalUserAttribute, optional)
- `apiKeys` (list of tgvalidatordInternalUserApiKey, optional)
- `visibilityGroups` (list of InternalUserVisibilityGroup, optional)
- `publicKeyEnforcedInRules` (boolean, optional)

### tgvalidatordInternalUserGroup

- `id` (string, optional)
- `externalGroupId` (string, optional)
- `enforcedInRules` (boolean, optional)

### InternalUserKeyContainer

- `value` (string, optional)
- `canBeStored` (boolean, optional)

### InternalUserAttribute

- `key` (string, optional)
- `value` (string, optional)
- `id` (string, optional)
- `contentType` (string, optional)
- `owner` (string, optional)
- `type` (string, optional)
- `subType` (string, optional)
- `isFile` (boolean, optional)
- `creationDate` (datetime, optional)
- `updateDate` (datetime, optional)

### tgvalidatordInternalUserApiKey

- `id` (string, optional)
- `creationDate` (datetime, optional)
- `revealDate` (datetime, optional)
- `lastUsed` (datetime, optional)
- `revealable` (boolean, optional)
- `verificationType` (enum, optional)
  - Allowed values: `HMAC`, `ECDSA`

### InternalUserVisibilityGroup

- `id` (string, optional)
- `name` (string, optional)
- `description` (string, optional)

## Examples

**Response**

```json
{
  "result": [
    {
      "id": "string",
      "tenantId": "string",
      "externalUserId": "string",
      "firstName": "string",
      "lastName": "string",
      "status": "string",
      "email": "string",
      "roles": [
        "string"
      ],
      "passwordChanged": true,
      "publicKey": "string",
      "groups": [
        {
          "id": "string",
          "externalGroupId": "string",
          "enforcedInRules": true
        }
      ],
      "enforcedInRules": true,
      "creationDate": "2024-01-15T09:30:00Z",
      "updateDate": "2024-01-15T09:30:00Z",
      "totpEnabled": true,
      "keyContainer": {
        "value": "string",
        "canBeStored": true
      },
      "username": "string",
      "lastLogin": "2024-01-15T09:30:00Z",
      "attributes": [
        {
          "key": "string",
          "value": "string",
          "id": "string",
          "contentType": "string",
          "owner": "string",
          "type": "string",
          "subType": "string",
          "isFile": true,
          "creationDate": "2024-01-15T09:30:00Z",
          "updateDate": "2024-01-15T09:30:00Z"
        }
      ],
      "apiKeys": [
        {
          "id": "string",
          "creationDate": "2024-01-15T09:30:00Z",
          "revealDate": "2024-01-15T09:30:00Z",
          "lastUsed": "2024-01-15T09:30:00Z",
          "revealable": true,
          "verificationType": "HMAC"
        }
      ],
      "visibilityGroups": [
        {
          "id": "string",
          "name": "string",
          "description": "string"
        }
      ],
      "publicKeyEnforcedInRules": true
    }
  ]
}
```

**SDK Code**

```python
import requests

url = "https://your-protect-instance.example.com/api/rest/v1/visibilitygroups/visibilityGroupID/users"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript
const url = 'https://your-protect-instance.example.com/api/rest/v1/visibilitygroups/visibilityGroupID/users';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://your-protect-instance.example.com/api/rest/v1/visibilitygroups/visibilityGroupID/users"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://your-protect-instance.example.com/api/rest/v1/visibilitygroups/visibilityGroupID/users")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://your-protect-instance.example.com/api/rest/v1/visibilitygroups/visibilityGroupID/users")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://your-protect-instance.example.com/api/rest/v1/visibilitygroups/visibilityGroupID/users', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://your-protect-instance.example.com/api/rest/v1/visibilitygroups/visibilityGroupID/users");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://your-protect-instance.example.com/api/rest/v1/visibilitygroups/visibilityGroupID/users")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```